<template>
    <div class="list">   
        <b-table :data="items"
                 focusable >
            <template slot-scope="props">
                <b-table-column field="id" label="ID">
                    {{props.row.id}}
                </b-table-column>
                <b-table-column field="tracker" label="Tracker" >
                   {{getTrackname(props.row.tracker)}}
                </b-table-column>
                <b-table-column field="status" label="Status">
                    {{getStatus(props.row.status)}}
                </b-table-column>
                <b-table-column field="priority" label="Priority">
                    {{props.row.priority}}
                </b-table-column>
                <b-table-column field="subject" label="Subject">
                    {{props.row.subject}}
                </b-table-column>
                <b-table-column field="assignee" label="Assignee">
                    {{getAssignee(props.row.assignee)}}
                </b-table-column>
                <b-table-column field="updated" label="Updated">
                    {{props.row.updated}}
                </b-table-column>
                <b-table-column field="duedate" label="Due date" width="110">
                    {{props.row.duedate}}
                </b-table-column>
            </template>
        </b-table>
    </div>  
</template>

<script>
import callApi from './../../middleware/apiCaller.js'
    export default {
        data(){
            return{
                items:[],
                taskAssignee:[],
                taskTracker:[],
                taskStatus:[],
                status:'',
                trackName:'',
                assignee:'',
            }
        },
        computed:{
        },
        mounted(){
            callApi('tasks','GET',null).then((res)=>{
                this.items=res.data
            })
            
            callApi('assignee','GET',null).then(res =>{
                this.taskAssignee=res.data
            })

            callApi('tracker','GET', null).then(res =>{
                this.taskTracker=res.data
            })

            callApi('status','GET', null).then(res =>{
                this.taskStatus=res.data
            })
        },
        methods:{
            getTrackname(id){
                for(let i=0; i < this.taskTracker.length; i++){
                    if(this.taskTracker[i].id === id){
                        return this.taskTracker[i].name
                    }
                }
            },
            
            getStatus(id){
                for(let i=0; i < this.taskStatus.length; i++){
                    if(this.taskStatus[i].id === id){
                        return this.taskStatus[i].status
                    }
                }
                
            },

            getAssignee(id){
                for(let i=0; i < this.taskAssignee.length; i++){
                    if(this.taskAssignee[i].id === id){
                        return this.taskAssignee[i].name
                    }
                }
            }
        },
        watch:{
            trackName(newTrackname){
                this.trackName=newTrackname;
            },
            status(newStatus){
                this.status=newStatus;
            }

        }
    }
</script>

<style scoped>

</style>